#include <gringo.h>
#include <stdio.h>
#include <string.h>
#include "chain.h"
#include "common_errors.h"
#include "press_any_key.h"
#include "probe_distributions.h"

int mount_distribution( TChain *plist) {
  TChainItem *item;
  TWindow *win;
  TGrid *grid;
  char *scelta;
    
  if ((plist==NULL)||(plist->count==0)) {  
    printf("Nessuna distribuzione trovata !\n");
    press_any_key();
    return ERROR_NOTFOUND;
  }

  printf("Distribuzioni trovate: %i \n", plist->count);

  if (plist->count==1) {  
    printf("Monto l'unica distribuzione trovata !\n");
    //mount_source_partition( plist->head->data );
    return 0;
  }

  printf("Piu' di una partizione, scegli quale ...\n");
  gringo_Init( NULL, NULL );
  win = window_Create( 10, 3, 60, 18, "Scelta della distribuzione da installare");
  grid = grid_Create( win, 2, 2, 56, 10 );
  grid_AddColumn( grid, "Device", 10);
  grid_AddColumn( grid, "Type", 10);
  grid_AddColumn( grid, "Description", 30);

  item = plist->head;
  while (item!=NULL) {
    grid_AddText(
      grid,
      TDISTRIBUTION(item->data)->name,
      TDISTRIBUTION(item->data)->device,
      item->name,
      NULL
    );
    item = item ->next;
  }

  gringo_Loop();
  scelta = strdup(grid->firstCol->activeItem->text);
  gringo_Quit();
  //pitem = choose_source_partition( plist );
  printf("\nLa partizione scelta e' %s", scelta );
  return 0;
}
