#define EXPORTS "export LD_LIBRARY_PATH=\"/target/lib:/target/usr/lib\"; "
#define SEDCOMMAND "/target/bin/sed"

static int write_fstab (void) {
  FILE *fstab;
  struct fdisk_partition *p;
  char* fsname;
  char* fsopts;

  if (NULL==(fstab=fopen("/target/etc/fstab","w"))){
    problemBox(MSG_CANT_OPEN_FSTAB,MSG_WRITE_ERROR);
    return 1;
  }

  if (is_nfs_partition("/target")) {
	fsname = "nfs";
	fsopts = "rw,rsize=8192,wsize=8192";
  }
  else {
	fsname = "ext2";
	fsopts = "defaults,errors=remount-ro";
  }
  fprintf(fstab,
"# /etc/fstab: static file system information.\n"
"#\n"
"# <file system> <mount point> <type> <options>                  <dump> <pass>\n"
"%-15s /             %s   %s 0      1\n",
  Root->name, fsname, fsopts);

  if (swapon_partitions != NULL) {
    p = swapon_partitions;
    while (p) {
      fprintf(fstab,
        "%-15s none          swap   sw                         0      0\n",
        p->name);
      p=p->next_in_use;
    }
  }

  fprintf(fstab,
"proc            /proc         proc   defaults                   0      0\n");

  fclose(fstab);

  sprintf(prtbuf,EXPORTS
      SEDCOMMAND
      " -n '/target\\//p' /etc/mtab | "
      SEDCOMMAND
      " -e 's/target\\///' -e 's/ 0 0/ 0 2/' -e 's/ rw / defaults /' "
      " >> /target/etc/fstab 2>/dev/null");
  if (system(prtbuf)) {
    problemBox(MSG_ERROR_WRITING_FSTAB,MSG_WRITE_ERROR);
    return 1;
  }
  return 0;
}


  sprintf(prtbuf,"cp /tmp/kbdconf /target/root/kbdconf");
  system(prtbuf);



  sprintf(prtbuf,"depmod -a ; /target/usr/sbin/modconf "
	" --libdir /target/usr/lib/module_help --exclude-section pcmcia"
	" --target /target --run-shell cdromsymlink");
  if (strncmp(real_kver,"2.0",3)) {
    /* not on 2.0 kernels:
     * workaround for serial consoles (/dev/tty is not avail) */
    strcat(prtbuf," --tty /dev/console");
  }
  system(prtbuf);


