
void
extract_archive (void)
{
  union block *data_block;
  int fd;
  int status;
  int name_length;
  int written;
  int openflag;
  long size;
  int skipcrud;
  int counter;
#if 0
  int sparse_ind = 0;
#endif
  union block *exhdr;
  struct delayed_set_stat *data;

#define CURRENT_FILE_NAME (skipcrud + current_file_name)

         JK - What we want to do if the file is sparse is loop through
	 the array of sparse structures in the header and read in and
	 translate the character strings representing 1) the offset at
	 which to write and 2) how many bytes to write into numbers,
	 which we store into the scratch array, "sparsearray".  This
	 array makes our life easier the same way it did in creating the
	 tar file that had to deal with a sparse file.

	 After we read in the first five (at most) sparse structures, we
	 check to see if the file has an extended header, i.e., if more
	 sparse structures are needed to describe the contents of the new
	 file.  If so, we read in the extended headers and continue to
	 store their contents into the sparsearray.  */

    case AREGTYPE:
    case REGTYPE:
    case CONTTYPE:
         JK - The last | is a kludge to solve the problem the O_APPEND
	 flag causes with files we are trying to make sparse: when a file
	 is opened with O_APPEND, it writes to the last place that
	 something was written, thereby ignoring any lseeks that we have
	 done.  We add this extra condition to make it able to lseek when
	 a file is sparse, i.e., we don't open the new file with this
	 flag.  (Grump -- this bug caused me to waste a good deal of
	 time, I might add)  */

    case GNUTYPE_VOLHDR:
      if (verbose_option)
	fprintf (stdlis, _("Reading %s\n"), current_file_name);
      break;

    case GNUTYPE_NAMES:
      extract_mangle ();
      break;

    case GNUTYPE_MULTIVOL:
      ERROR ((0, 0, _("\
Cannot extract `%s' -- file is continued from another volume"),
	      current_file_name));

    case GNUTYPE_LONGNAME:
    case GNUTYPE_LONGLINK:
      ERROR ((0, 0, _("Visible long name error")));
      skip_file ((long) current_stat.st_size);
      if (backup_option)
	undo_last_backup ();
      break;



~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
/* "Scratch" space to store the information about a sparse file before
   writing the info into the header or extended header.  */
struct sp_array *sparsearray;
/* Number of elts storable in the sparsearray.  */
int   sp_array_size = 10;

struct delayed_set_stat
  {
    struct delayed_set_stat *next;
    char *file_name;
    struct stat stat_info;
  };

static struct delayed_set_stat *delayed_set_stat_head;


static void
extract_sparse_file (int fd, long *sizeleft, long totalsize, char *name)
{
  union block *data_block;
  int sparse_ind = 0;
  int written, count;

  /* FIXME: `data_block' might be used uninitialized in this function.
     Reported by Bruno Haible.  */

  /* assuming sizeleft is initially totalsize */

  while (*sizeleft > 0)
    {
      data_block = find_next_block ();
      if (data_block == NUdata_block == NUdata_block == NUdata_block == NUdata_block == NUdata_block == NUdata_block == NUdata_bloy[sparse_ind].offset, 0);
      written = sparsearray[sparse_ind++].numbytes;
      while (written > BLOCKSIZE)
	{
	  count = write (fd, data_block->buffer, BLOCKSIZE);
	  if (count < 0)
	    ERROR ((0, errno, _("%s: Could not write to file"), name));
	  written -= count;
	  *sizeleft -= count;
	  set_next_block_after (data_block);
	  data_block = find_next_block ();
	}

      count = write (fd, data_block->buffer, (size_t) written);

      if (count < 0)
	ERROR ((0, errno, _("%s: Could not write to file"), name));
      else if (count != written)
	{
	  ERROR ((0, 0, _("%s: Could only write %d of %d bytes"),
		     name, count, totalsize));
	  skip_file ((long) (*sizeleft));
	}

      written -= count;
      *sizeleft -= count;
      set_next_block_after (data_block);
    }
  free (sparsearray);
  set_next_block_after (data_block);
}
